-- class variables
OhaiyoClasses_BasicFrame = {
	-- private variable
	frame = nil,
	frameTexture = nil,
	backgroundFrame = nil,
	backgroundFrameTexture = nil,
	referenceFrame = nil,
}

OhaiyoClasses_BasicFrame.__index = OhaiyoClasses_BasicFrame

function OhaiyoClasses_BasicFrame.create()
	local newInstance = {}
	setmetatable(newInstance, OhaiyoClasses_BasicFrame)

	newInstance.frame = CreateFrame("Frame", nil, UIParent, nil)
	newInstance.backgroundFrame = CreateFrame("Frame",nil,UIParent,nil)
	newInstance.referenceFrame = CreateFrame("Frame",nil,UIParent,nil)
	newInstance.text = newInstance.frame:CreateFontString(nil, "OVERLAY", "GameFontNormal")

	return newInstance
end

function OhaiyoClasses_BasicFrame:PositionFrames(point, anchor, relativePoint, width, height, xpos, ypos)
	self.referenceFrame:SetSize(width, height)
	self.referenceFrame:SetPoint(point, anchor, relativePoint, xpos, ypos)

	-- setting up the dark background
	self.backgroundFrame:SetFrameStrata("BACKGROUND")
	self.backgroundFrame:SetSize(width - 2, height - 2)
	self.backgroundFrame:SetPoint("BOTTOMLEFT", self.referenceFrame, "BOTTOMLEFT", 1, 1)

	-- setting up frame bars
	self.frame:SetFrameStrata("MEDIUM")
	self.frame:SetSize(width - 6, height - 6)
	self.frame:SetPoint("BOTTOMLEFT", self.backgroundFrame, "BOTTOMLEFT", 2, 2)

	self.text:SetPoint("CENTER", 0, 0)
	self.text:SetSize(width - 6, height - 6)
	self.text:SetJustifyH("CENTER")
	self.text:SetWordWrap(true)
	self.text:SetNonSpaceWrap(true)
end

-- updating frame functions
function OhaiyoClasses_BasicFrame:SetTexture(texture, r, g, b, a)
	self.frameTexture = self.frame:CreateTexture(nil, "LOW")
	self.frameTexture:SetTexture(texture)
	self.frameTexture:SetVertexColor(r, g, b, a)
	self.frameTexture:SetAllPoints(self.frame)
	self.frame.texture = self.frameTexture
end

function OhaiyoClasses_BasicFrame:SetBackground(texture, r, g, b, a)
	self.backgroundFrameTexture = self.backgroundFrame:CreateTexture(nil, "BACKGROUND")
	self.backgroundFrameTexture:SetTexture(texture)
	self.backgroundFrameTexture:SetVertexColor(r, g, b, a)
	self.backgroundFrameTexture:SetAllPoints(self.backgroundFrame)
	self.backgroundFrame.texture = self.backgroundFrameTexture
end

function OhaiyoClasses_BasicFrame:SetColor(r, g, b, a)
	self.backgroundFrameTexture:SetVertexColor(r, g, b, a)
end

function OhaiyoClasses_BasicFrame:Show()
	self.frame:Show()
	self.referenceFrame:Show()
	self.backgroundFrame:Show()
end

function OhaiyoClasses_BasicFrame:Hide()
	self.frame:Hide()
	self.referenceFrame:Hide()
	self.backgroundFrame:Hide()
end

function OhaiyoClasses_BasicFrame:SetText(newText)
	self.text:SetText(newText)
end

function OhaiyoClasses_BasicFrame:SetFont(font, size, r, g, b, a)
	self.text:SetFont(font, size)
	self.text:SetTextColor(r, g, b, a)
end

function OhaiyoClasses_BasicFrame:GetFrame()
	return self.referenceFrame
end
